#!/bin/sh
avhsparam=root.RemoteService.Enabled
firmware560=0
fwparam=root.Properties.Firmware.Version
if parhandclient get $fwparam  | grep  '^"5\.6' > /dev/null; then
    firmware560=1
fi
fw820plus_ntpconf="[Service]
ExecStartPre=/bin/sh -c \"cat /run/ntp/ntpd.conf | grep 'listen on *' >>/dev/null || echo 'listen on *' >> /run/ntp/ntpd.conf\""

rm -rf /usr/html/local/parking /usr/html/local/occupancy-estimator /usr/html/local/people-counter /usr/html/local/heatmap /usr/html/local/bicycle
rm -rf /etc/apache2/conf.d/tvgd.conf
rm -rf /etc/apache2/conf.d/tvpc.conf
rm -rf /etc/apache2/conf.d/tvqu.conf
rm -rf /etc/apache2/conf.d/vhosts/all/tvgd.conf
rm -rf /etc/apache2/conf.d/vhosts/all/tvqu.conf
rm -rf /etc/apache2/conf.d/vhosts/all/tvpc.conf
rm -rf /etc/apache2/conf.d/vhosts/all/urls_tvpc.conf # Remove due to 8.30 firmware includes new permissions

mkdir -p /usr/local/sbin/

# DO THIS ONLY FOR PRE 8.10 FW RELEASE
if [ -f /usr/libexec/ntp-tools ]; then
    cp /usr/local/packages/tvpc/time-source.service /etc/systemd/system/
    cp /usr/local/packages/tvpc/ntp.service /etc/systemd/system/
    cp /usr/local/packages/tvpc/ntp-SDK2 /usr/local/sbin/ntp-tools
    cp /usr/local/packages/tvpc/ntp-init /usr/local/sbin/
    chmod 755 /usr/local/sbin/ntp-tools
    chmod 755 /usr/local/sbin/ntp-init
    systemctl daemon-reload > /dev/null 2>&1
    systemctl restart time-source.service >/dev/null 2>&1
else
    # Remove old configurations if present
    rm -f /etc/systemd/system/time-source.service
    rm -f /etc/systemd/system/ntp.service
    rm -rf /etc/systemd/system/ntp.service.d/

    mkdir -p /etc/systemd/system/ntp.service.d/
    if /usr/sbin/ntpd -rn > /dev/null 2>&1; then # FW >= 8.20 - check if -r option exists, -n is no action
        echo "NTPD_ARGS=-r -t 60" > /run/ntp/ntp.cmd_args
        echo "$fw820plus_ntpconf" > /etc/systemd/system/ntp.service.d/ntp-server.conf
    else # in 8.10 <= FW <= 8.15 -r option is not present
        cp /usr/local/packages/tvpc/ntp-server.conf /etc/systemd/system/ntp.service.d/
        cp /usr/local/packages/tvpc/ntpd /usr/local/sbin
    fi
    systemctl daemon-reload > /dev/null 2>&1

    # AVHS stops ntp server and performs their own syncing,
    # only restart ntp service if AVHS is inactive.
    if [ "$(parhandclient get $avhsparam)" != '"yes"' ]; then
        systemctl restart ntp.service
    fi
fi

cp /usr/local/packages/tvpc/html/occupancy-estimator/public/* /mnt/flash/etc/httpd/html/administrator/

parhandclient --nocgi set root.Network.Bonjour.FriendlyName "AXIS Occupancy Estimator - `parhandclient --nocgi get root.Brand.ProdShortName - RAW` - `parhandclient --nocgi get root.Properties.System.SerialNumber - RAW`" 2>/dev/null > /dev/null

#if [ "$firmware560" -eq "1" ]; then
#    BOAPID=`pidof boa`
#    BOAOUT_=`stat /proc/$BOAPID/fd/* | grep pipe`
#    BOAOUT=`echo $BOAOUT_ | cut -d' ' -f2 | tr -d \'`
#    eval `sed -n 'H;${x;s/\(^\|\x00\)\([^=]*.\)\([^\x00]*\)/\2\x27\3\x27\n/gp}' /proc/$PPID/environ | grep HTTP_HOST`
#    echo -en 'Location: http://'$HTTP_HOST'/local/occupancy-estimator/wait.html\r\n' > $BOAOUT
#    echo -en 'Content-type: text/plain\r\n\r\n' > $BOAOUT
#else
#    echo -en 'Location: http://'$HTTP_HOST'/local/occupancy-estimator/wait.html\r\n'
#    echo -en 'Content-type: text/plain\r\n\r\n'
#fi
#/etc/init.d/httpd restart  >/dev/null  2>&1

# Make sure apache (user www) can access our html directory
chown www -R /usr/local/packages/tvpc/html/

# Add Possibility for viewer to see interface and then set specifc permissions for files.
find /usr/local/packages/tvpc/html/* -type d | xargs chgrp  viewer
find /usr/local/packages/tvpc/* -type d | xargs  chmod 740
find /usr/local/packages/tvpc/* -type f | egrep -v "params.meta" | xargs chgrp viewer
find /usr/local/packages/tvpc/* -type f | egrep -v "params.meta" | xargs chmod 740
chgrp root /usr/local/packages/tvpc/localdata/params.meta
chmod 600 /usr/local/packages/tvpc/localdata/params.meta

chmod 750 /usr/local/packages/tvpc/html/occupancy-estimator
chmod 750 /usr/local/packages/tvpc/html/
chmod 644 /usr/local/packages/tvpc/LICENSE
chmod 644 /usr/local/packages/tvpc/conf/sdktvpc.service
chgrp admin /usr/local/packages/tvpc/html/occupancy-estimator/.apiadmin
chgrp operator /usr/local/packages/tvpc/html/occupancy-estimator/.apioperator
chgrp operator /usr/local/packages/tvpc/html/occupancy-estimator/registration.html
chgrp operator /usr/local/packages/tvpc/html/occupancy-estimator/javascript/registration.js

#Remove axis-created .htaccess files that only allow admin access
find /usr/local/packages/tvpc/html/ -name .htaccess | xargs rm

#Create symlink to axis html so that we can redirect to its index.shtml from /admin/ without
#triggering the previous redirect from /index.shtml to /occupancy-estimator/statistics.html
ln -sf /usr/html/ /usr/local/packages/tvpc/html/occupancy-estimator/axis-html

#Sets apache rewrite rules that redirects /occupancy-estimator/ to /local/tvpc/occupancy-estimator/. This is not removed on uninstallation.
#On >5.80 the vhosts folder was added requiring a new placement of the conf file.
if [ -d "/etc/apache2/conf.d/vhosts/all/" ]; then
    cp /usr/local/packages/tvpc/apache.conf /etc/apache2/conf.d/vhosts/all/tvpc.conf
else
    cp /usr/local/packages/tvpc/apache.conf /etc/apache2/conf.d/tvpc.conf
    # Patch 5.70.1
    if md5sum /etc/apache2/httpd-ssl.conf | grep 36d18473ace756a42947e826cc8c7ee9; then
        echo Patching httpd-ssl.conf to fix issue in 5.70 and 5.75.
        cp httpd-ssl.conf.5.70 /etc/apache2/httpd-ssl.conf
    fi
fi

#The transfer_tvpc.conf file is automatically created with /local/tvpc/ prepended to path set in PeopleCounter-cgipaths.conf.
#For our redirecting to work however this prepending must be removed.
sed -rne 's/\/local\/tvpc\//\//p' /etc/apache2/transfer/transfer_tvpc.conf > transfer_tvpc.conf.tmp
cat transfer_tvpc.conf.tmp > /etc/apache2/transfer/transfer_tvpc.conf
rm transfer_tvpc.conf.tmp

#Start tvpc via axis api. Sleep 5 to let axis restart httpd first.
if systemctl status | grep [a]capmanager >/dev/null 2>&1; then
    echo ENABLED=yes > /usr/local/packages/tvpc/conf/runstate.conf
else
    sleep 5
    export QUERY_STRING="action=start&package=tvpc"
    /usr/html/axis-cgi/applications/control.cgi >/dev/null  2>&1
fi

#Remove old acap specific account because password weakness.
export QUERY_STRING="action=get"
if /usr/html/axis-cgi/pwdgrp.cgi | grep TrueviewVAPIX >/dev/null; then
    QUERY_STRING="action=remove&user=TrueviewVAPIX" /usr/html/axis-cgi/pwdgrp.cgi >/dev/null 2>&1
fi

echo 'postinstall reached end of file'
